=encoding utf8

=head1 NAME

Mail::Message::TransferEnc::QuotedPrint - handle quoted-printable message bodies

=head1 INHERITANCE

 Mail::Message::TransferEnc::QuotedPrint
   is a Mail::Message::TransferEnc
   is a Mail::Reporter

=head1 SYNOPSIS

  my Mail::Message $msg = ...;
  my $decoded = $msg->decoded;
  my $encoded = $msg->encode(transfer => 'quoted-printable');

=head1 DESCRIPTION

Encode and decode message bodies for quoted-printable transfer encoding.
The Quoted-Printable encoding is intended
to represent data that largely consists of bytes that correspond to
printable characters in the ASCII character set.  Non-printable
characters (as defined by English Americans) are represented by a
triplet consisting of the character "=" followed by two hexadecimal
digits.

Extends L<"DESCRIPTION" in Mail::Message::TransferEnc|Mail::Message::TransferEnc/"DESCRIPTION">.

=head1 METHODS

Extends L<"METHODS" in Mail::Message::TransferEnc|Mail::Message::TransferEnc/"METHODS">.

=head2 Constructors

Extends L<"Constructors" in Mail::Message::TransferEnc|Mail::Message::TransferEnc/"Constructors">.

=over 4

=item $class-E<gt>B<new>(%options)

Inherited, see L<Mail::Reporter/"Constructors">

=back

=head2 Attributes

Extends L<"Attributes" in Mail::Message::TransferEnc|Mail::Message::TransferEnc/"Attributes">.

=head2 The Encoder

Extends L<"The Encoder" in Mail::Message::TransferEnc|Mail::Message::TransferEnc/"The Encoder">.

=over 4

=item $class-E<gt>B<addTransferEncoder>($type, $class)

Inherited, see L<Mail::Message::TransferEnc/"The Encoder">

=item $obj-E<gt>B<create>($type, %options)

Inherited, see L<Mail::Message::TransferEnc/"The Encoder">

=item $obj-E<gt>B<name>()

Inherited, see L<Mail::Message::TransferEnc/"The Encoder">

=back

=head2 Encoding

Extends L<"Encoding" in Mail::Message::TransferEnc|Mail::Message::TransferEnc/"Encoding">.

=over 4

=item $obj-E<gt>B<check>($body, %options)

Inherited, see L<Mail::Message::TransferEnc/"Encoding">

=item $obj-E<gt>B<decode>($body, %options)

Decoding is tricky, and not without loss of information.  Lines will
stay separate lines, although they might have been joined before the
encoding split them up.  Characters which are not printable will be
replaced by their octal value, and carriage returns (C<'=0D'>) at
end of line are removed.
Improves base, see L<Mail::Message::TransferEnc/"Encoding">

 -Option     --Defined in                --Default
  result_type  Mail::Message::TransferEnc  <type of source body>

=over 2

=item result_type => CLASS

=back

=item $obj-E<gt>B<encode>($body, %options)

Encoding is to quoted-printable is a careful process: All characters
outside the normal printing range, and including C<'='> are encoded.
They are translated into a C<'='> followed by a two digit hex of the
ascii value of the character.  The same treatment is for white-spaces
at the end of a line.

The lines which are constructed which must be 76 characters max, not
broken on encoded characters.
Improves base, see L<Mail::Message::TransferEnc/"Encoding">

 -Option     --Defined in                --Default
  result_type  Mail::Message::TransferEnc  <type of source body>

=over 2

=item result_type => CLASS

=back

=back

=head2 Error handling

Extends L<"Error handling" in Mail::Message::TransferEnc|Mail::Message::TransferEnc/"Error handling">.

=over 4

=item $obj-E<gt>B<AUTOLOAD>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<notImplemented>()

Inherited, see L<Mail::Reporter/"Error handling">

=back

=head2 Cleanup

Extends L<"Cleanup" in Mail::Message::TransferEnc|Mail::Message::TransferEnc/"Cleanup">.

=over 4

=item $obj-E<gt>B<DESTROY>()

Inherited, see L<Mail::Reporter/"Cleanup">

=back

=head1 DIAGNOSTICS

=over 4

=item Error: class $package does not implement method $method.

Fatal error: the specific C<$package> (or one of its superclasses) does not
implement this method where it should. This message means that some other
related classes do implement this method however the class at hand does
not.  Probably you should investigate this and probably inform the author
of the package.
Cast by C<notImplemented()>

=item Error: decoder for transfer encoding $type does not work: $@

Compiling the required transfer encoding resulted in errors, which means
that the decoder can not be used.
Cast by C<create()>

=item Error: no decoder for transfer encoding $type.

A decoder for the specified type of transfer encoding is not implemented.
Cast by C<create()>

=back

=head1 SEE ALSO

This module is part of Mail-Message version 4.03,
built on January 26, 2026. Website: F<http://perl.overmeer.net/CPAN/>

=head1 LICENSE

For contributors see file ChangeLog.

This software is copyright (c) 2001-2026 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

